# coding: utf-8

"""
    Tripartie

    Our API suite for the **Resolution Center** and the **Safe Checkout** features. Simple, yet elegant web interfaces for your convenience. One request away from your first automated resolution or safe-checkout.

    The version of the OpenAPI document: 2.0.74
    Contact: noc@tripartie.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class DisputePostCreationRead(BaseModel):
    """
    Access directly our resolution center without having used the safe-checkout feature.  # noqa: E501
    """
    ulid: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    buyer_id: Optional[StrictInt] = Field(None, alias="buyerId")
    seller_id: Optional[StrictInt] = Field(None, alias="sellerId")
    offer_ulid: Optional[StrictStr] = Field(None, alias="offerUlid")
    __properties = ["ulid", "url", "buyerId", "sellerId", "offerUlid"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DisputePostCreationRead:
        """Create an instance of DisputePostCreationRead from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "buyer_id",
                            "seller_id",
                            "offer_ulid",
                          },
                          exclude_none=True)
        # set to None if url (nullable) is None
        # and __fields_set__ contains the field
        if self.url is None and "url" in self.__fields_set__:
            _dict['url'] = None

        # set to None if buyer_id (nullable) is None
        # and __fields_set__ contains the field
        if self.buyer_id is None and "buyer_id" in self.__fields_set__:
            _dict['buyerId'] = None

        # set to None if seller_id (nullable) is None
        # and __fields_set__ contains the field
        if self.seller_id is None and "seller_id" in self.__fields_set__:
            _dict['sellerId'] = None

        # set to None if offer_ulid (nullable) is None
        # and __fields_set__ contains the field
        if self.offer_ulid is None and "offer_ulid" in self.__fields_set__:
            _dict['offerUlid'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DisputePostCreationRead:
        """Create an instance of DisputePostCreationRead from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DisputePostCreationRead.parse_obj(obj)

        _obj = DisputePostCreationRead.parse_obj({
            "ulid": obj.get("ulid"),
            "url": obj.get("url"),
            "buyer_id": obj.get("buyerId"),
            "seller_id": obj.get("sellerId"),
            "offer_ulid": obj.get("offerUlid")
        })
        return _obj


